\documentclass[a4paper,11pt]{article}

%\usepackage[english]{babel}
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}

\usepackage{amsmath}
\usepackage{amsfonts}
\usepackage{amssymb}
\usepackage{amsthm}

\usepackage{graphicx}
\usepackage{caption}
\usepackage{subcaption}

\usepackage{hyperref}
\usepackage{url}

\usepackage{tikz}
\usetikzlibrary{arrows}
\usetikzlibrary{backgrounds}
\usetikzlibrary{decorations.pathmorphing}
\usetikzlibrary{graphs}
\usetikzlibrary{shapes.geometric}
\usetikzlibrary{calc}
\usetikzlibrary{patterns}
\usetikzlibrary{decorations.markings}
\usepackage{lettrine}
\usepackage{titlesec}
\usepackage{fancyhdr}

%\usepackage{algorithm}
%\usepackage{algorithmic}
%\usepackage[usenames]{color}
\usepackage{listings}
%\usepackage{dtsyntax}

\usepackage{siunitx}
\usepackage[siunitx,europeanresistors,americanvoltages]{circuitikz}

\usepackage{mgbondgraph}

%========== okraje stranky ====================================

\oddsidemargin 0.5cm 
\evensidemargin 0.5cm

\topmargin 3pt
\headheight 15pt
\headsep 20pt

\textwidth 13cm

\marginparwidth 3cm 
\marginparsep 0.5cm 

\textheight 21cm
\footskip 2cm
 
%============== nove prikazy a prostredi ============================

\newtheorem{example}{Example}[section]

%======================================================

\definecolor{cvutdarkblue}{RGB}{0,99,168}
\definecolor{cvutlighterblue}{RGB}{112,153,204}
\definecolor{cvutlightestblue}{RGB}{217,227,245}
\definecolor{light-gray}{gray}{0.75}

\lstset{language=Matlab, basicstyle=\scriptsize, keywordstyle=\color{blue}, backgroundcolor=\color{light-gray}}

%============== zahlavi a zapati ======================

\pagestyle{fancy}

\fancyhead{}
\rhead{\bfseries Mathematical models of dynamic systems}

\fancyfoot{}
\rfoot{\thepage}
\lfoot{Lecture 1 on Modeling and Simulation of Dynamic Systems}

\renewcommand{\headrulewidth}{0.4pt}
\renewcommand{\footrulewidth}{0.4pt}

%\titleformat*{\section}{\fontfamily{pag}\fontsize{14pt}{16pt}\selectfont}
%============== opening ================================

\begin{document}

\thispagestyle{empty}

\begin{tikzpicture}[remember picture,overlay]

\coordinate [below=2.5cm] (midpoint) at (current page.north);

\node [name=colourbar,
draw=cvutlighterblue,
anchor=base,
fill=cvutlighterblue,
text = white,
minimum width=\paperwidth,
minimum height=1cm] at (midpoint) {};

% Define the point where the logo will go
\coordinate [right=20cm] (number) at (colourbar.west);

% Set coordinate system origin
\begin{scope}[shift=(number)]
% Draw the outline
\filldraw [cvutdarkblue] (1.3,0.5) -- ++(-2,0) -- ++(-0.8,-1) -- ++(2.8,0) --cycle;
% Include the logo
\node [text=white] {\Huge{\textbf{1}}};
\end{scope}

\end{tikzpicture}

%\vspace{-0.8cm}

\noindent
{\fontfamily{pag}\fontsize{31pt}{37pt}\selectfont Introduction to modeling}\\
\vspace{0.8cm}
{\fontfamily{pag}\fontsize{12pt}{12pt}\selectfont  Overview of mathematical models of dynamic systems}\\
\vspace{0.0cm}
%\begin{flushleft}fdsfs\end{flushleft}                 
\begin{flushright}{\fontfamily{pag}\fontsize{12pt}{14pt}\fontshape{it}\selectfont  Zden\v ek Hur\' ak}\\\today\end{flushright}
\vspace{0.8cm}

\lettrine{I}{n} this introductory lecture we will discuss what we actually mean by modeling of dynamic systems in this course. Apparently, the topic is tremendously broad but keep in mind that our key ultimate motivation is to assist in a controller design. This will shape the whole course. We will see an overview of formats of mathematical models that we intend to use in the rest of the course. Some of them will be notoriosly known (state-space equations, transfer functions), some will be less familiar (differential-algebraic equations), multi-ports, bond graphs). This course has an ambition to teach you the skill (or even the art) of modeling of realistically complex systems, and in order to achieve it, it seems inevitable to follow the bottom-up approach, starting with simpler subsystems and components. We will see at the very beginning that following this reasonable approach turns out plain impossible when sticking to the widely popular the formalism of block diagrams (or signal flow models in the Simulink style). It will turn out that the interface between components and subsystems which describes exchange of energy rather then passing of signals is better suited for the component-based and multi-domain modeling. The powerful concept of energy-based modeling will be introduced in this introductory lecture and contrasted with signal-based modeling. The very key idea of the modeling methodology based on bond graphs will be introduced.


\section{What do we mean by model and modeling?}
Long introductory paragraphs can be written on the definitions of the concepts of system and model. We will skip these while directing a student to any of the many available texts (see the discussion of literature at the end of this text) and state (maybe too abruptly) that \emph{system} is whatever you define it to be... Well, perhaps this was too abrupt, there are at least two atributes that must be specified: 

\begin{itemize}
 \item the \textit{boundaries} of the system, which do not necessarily have to coincide with the physical borders of the object as in the case of flight dynamics where the flight is due to interaction of the aircraft and the bulk of air surrounding it, 
 \item and the relevant \textit{variables} (while studying flight dynamics, you are certainly not interested in knowing temperature distribution over the control surfaces).
\end{itemize}

In this course we are going to consider dynamic systems, that is, system which exhibit \textit{inertia}, some sluggishness (not exactly a delay) in response to external stimuli.

Now, model of a system is our structured knowledge that helps forecast the behavior of the system. In our course we only consider mathematical models, that is, mathematical equations that relate the physical variables characterizing the system under study. Having specified that we are interested in dynamic systems, differential and/or algebraic equations seem to be the right tool for description of such systems, although these need not be explicitly written down but rather encoded in a graphical form or software code.   

Towards the end of the course we are going to enter the discipline of \textit{simulation} of dynamic systems. Suffice to say for now that it is a numerical experimentation with the mathematical model.

\section{What is our motivation for modeling?}
Modeling is a skill exercised by perhaps every engineer and scientist. The number of expert domains is huge, as well as the number of motivations of these experts. Starting our course, we need to identify our goal and keep it in mind throughout the course, otherwise we will be chasing everyone else's job and responsibility. Well then, we are control engineers and our ultimate goal is to design a control system. Hence, we only need a model for

\begin{enumerate}
 \item approximate analysis of the system (to learn fundamental limitations of on achievable control performance)
 \item design a control systems (feedback and/or feedforward loops, filters on measured variables, shapers for reference variables)
 \item simulation of the response of the resulting system (original system plus our control system) to assess the performance. 
\end{enumerate}

Of course, in a well-managed project, control engineers have some interactions with designers of the system, therefore lessons learnt from some early control-centered analysis of mathematical models can induce some modification of the design (choice of more powerful motors, less noisy sensors, or even a complete redesign of mechanical configuration), but most often than not we are free from the design worries. 

Furthemore, our models do not have to describe the reality perfectly! They only need to be just as accurate as we need to guarantee a requested closed-loop performance. 

Models can also be used for other purposes than control design. Employing real-time simulation, models can be used for detection of some failure modes.

\section{Classes of systems we are going to model}
Although many of the concepts introduced in this course are quite versatile, we opt to focus the course on systems where the concept of \textit{energy} makes sense. These include electronic, electrical, mechanical, electromechanical, hydraulic, magnetic, thermal, thermofluidic and perhaps some other technical systems.

Relying on the unifying concept of energy we could achieve even more then just step into the someone elses' domain of expertize, we could \textit{connect} these domains within a single project. After all, these integration skills are typical for control engineers. To summarize, the modeling methods presented in this course will make it possible to model systems with these two attributes

\begin{itemize}
 \item multidomain systems: mechanical, electrical, hydraulic, thermal, \ldots
 \item complex: composed of a large number of interacting subsystems and compoments. 
\end{itemize}

To pick a single system perfectly demonstrating the above two atributes, consider the laboratory-scale pump storage power plant as located in our ``Strojovna'' lab with the schematics given in Fig.~\ref{fig:elektrarna} and described in some detail in the corresponding section of the course website \cite{msd_elektrarna_2013}.

\begin{figure}[ht]
 \centering
 \includegraphics[width=5cm]{./figures/vodni_elektrarna_schema.png}
 % elektrarna_schema.png: 286x482 pixel, 72dpi, 10.09x17.00 cm, bb=0 0 286 482
 \caption{Laboratory-scale pump storage power plant as located in our ``Strojovna'' lab.}
 \label{fig:elektrarna}
\end{figure}

Apparently, the three major physical domains are included in this project: electrical (motors), mechanical (valves), hydraulic (pipes, tanks). Moreover, the system is no longer of a toy size.

\section{Classes of systems we are not going to model}

Unfortunately, many interesting systems encountered in the fields such as sociology, economy, and even biology are based on transfer of \textit{information} rather then energy and we will not investigate these.

This is an itroductory course and inevitably we had to skip many modeling concepts. One of the key concepts that we do not cover at all is that of stochastic systems and their models. Talking about these would first need solid basis in probability and random processes, for which we do not have space in our course. 

\section{Modeling approaches presented in our course}
As energy is the unifying phenomenon across physical domains and systems, our methods will be based on it in one way or another. We will study three classes of methods. Studying them deeper, these could be eventually shown to be just different facets of the same basic modeling philosophy. 
 
\begin{enumerate}
 \item graphical technique of \textit{bond graphs},
 \item software technique of \textit{object-oriented modeling} (also equation-based modeling), in particular the popular Modelica language (or recently also Simscape language by The Mathworks),
 \item analytical techniques of Lagrange and Hamilton.
\end{enumerate}

\section{Modeling approaches not presented in our course}
Related to stochastic systems is the discipline of \textit{systems identification}, which can also be regarded as a modeling methodology. Based on the collected measurements of the inputs and outputs, a mathematical mode is build which best relates the two data sets. We are not going to study this either. Besides the already expressed capacity arguments, system identification represents a methodology which is in some sense orthogonal to our approach. It is certainly wise to regard system identification as a complementary technique, not the key line of attack.

\section{Mathematical models of dynamic systems}

\subsection{Causal models (also assignment-based, signal-based)}
We start the survey of formats of mathematical models of dynamic systems by a couple of fairly popular formats which we collectively label as ``causal'' or ``signal-based'' or ``assignment-based''. It will only be explained later in this lecture what we mean by these adjectives.

\subsubsection{State equations}

Our focus in this course is on dynamical systems, hence differential equations are the key mathematical vehicle here. Among these, the first-order explicit ordinary differential equations are certainly the most studied and you have surely encountered these under the name of a \textit{state equations}. These equations are generally nonlinear and possibly also time varying

\begin{equation}\label{eq:nonlinear_state_equation}
 \frac{\mathrm{d} x(t)}{\mathrm{d}t} = f(x(t),u(t),t).
\end{equation}

Recall that in order to specify a unique solution, the initial conditions, that is, the value of the state variable $x(t)$ at the initional time $t_0$ needs to be specified

\begin{equation}
x(t_0) = x_0. 
\end{equation}

This can also represent a situation in which $x(t)$ denotes an $n$-tuple of variables, that is, $x(t)\in\mathbb{R}^{n}$, $u(t)$ is an $m$-tuple of inputs, that is, $u\in \mathbb R^m$, and $f$ is a vector-valued function. It is a good practice to use a bold face for vector variables and therefore we write

\begin{equation}\label{eq:nonlinear_vector_state_equation}
 \frac{\mathrm{d} \boldsymbol x(t)}{\mathrm{d}t} = \mathbf f(\boldsymbol x(t),\boldsymbol u(t),t).
\end{equation}

The $x(t)$ variable is called \emph{state} variable. This name reflects the fact that in order to predict the system's response to some external stimulus $u(t)$, we only need to know the value of $x(t)$ right at the moment $t_0$ of application of the external signal. No past values are needed to determine the response of the system uniquely. 

Speaking about existence and uniqueness of a solution, we omit here a lengthy discussion of the underlying mathematical issues, which were certainly included in some previous mathematical course. In a few words, the $f()$ function above needs to be sufficiently ``smooth", namely, it must satisfy so-called Lipschitz conditions with respect to $x$. Suffice to say that for physically motivated equations the existence and uniqueness of the solution are automatically guaranteed, at least on a finite time inteval (see \textit{finite escape time}). 

The current value of $x(t_0)$ now includes all the information to determine the future values of $x(t)$ in presence of the input $u()$ (on the interval $[t_0,t]$). Compare with, say, the second-order differential equation expressing Newton's law

\begin{equation}
 m\ddot x(t) = F(t).
\end{equation}

In order the predict how the trajectory $x(t)$ of the system evolves in time in response to a change in the force $F(t)$ applied at some time $t_0$, knowledge of the initial position $x(t_0)$ is not enough! We also need to know the value of its derivative at the initial time, that is, the initial velocity $\dot x(t_0)$. It is generally possible to transform (we say "realize") a given differential equation into a state-space format. We can do this by introduction a new state variable---velocity in our example:

\begin{equation}
 \begin{bmatrix}\dot x_1(t)\\ \dot x_2(t)\end{bmatrix} 
= 
\begin{bmatrix}
  0 & 1\\
  0 & 0
\end{bmatrix}
\underbrace{\begin{bmatrix}x_1(t)\\x_2(t)\end{bmatrix}}_{\boldsymbol{x(t)}}
+
\begin{bmatrix}0\\\frac{1}{m}\end{bmatrix}
\underbrace{F(t)}_{u(t)}.
\end{equation}
 
The state equation is often accompanied by the \textit{output equation}, which in the vector form is

\begin{equation}\label{eq:nonlinear_output_equation}
 \boldsymbol y(t) = \mathbf g(\boldsymbol x(t), \boldsymbol u(t), t),
\end{equation}
which only shows how some of the state variables are scaled and combined in order to create the output variables. For instance, the output variables can include just some subset of physically measurable state variables. You are certainly already familiar with the linear(ized) version

\begin{equation}\label{eq:linear_time_varying_state_space_model}
 \begin{split}
 \dot{\boldsymbol x}(t) &= \mathbf A(t)\boldsymbol x(t) + \mathbf B(t)\boldsymbol u(t),\\
 \boldsymbol y(t) &= \mathbf C(t)\boldsymbol x(t) + \mathbf D(t) \boldsymbol u(t). 
 \end{split}
\end{equation}

Most often the matrices involved in the model were independent of time

\begin{equation}\label{eq:linear_time_invariant_state_space_model}
 \begin{split}
 \dot{\boldsymbol x}(t) &= \mathbf A\boldsymbol x(t) + \mathbf B\boldsymbol u(t),\\
 \boldsymbol y(t) &= \mathbf C\boldsymbol x(t) + \mathbf D \boldsymbol u(t). 
 \end{split}
\end{equation}
in which case we talk about an LTI (linear time invariant) system. 

Frequently uses is the following compact way of writing down a state-space LTI model (named somehow, say, $\boldsymbol{G}$)
\begin{equation}
 \boldsymbol{G} = \left[\begin{array}{c|c}
      \mathbf A & \mathbf B\\\hline \mathbf C & \mathbf D
     \end{array}\right].
\end{equation}

Make sure you do understand, what makes a linear system linear\ldots Make sure you are familiar with the relationship between the size of the matrices and the dimension of the state vector and number of input and output variables.

Before we show an example of a state-space model, we first introduce another format of a model, which generalizes the state-space model.

\subsubsection{DAE models, also singular or descriptor models}
Strictly speaking, the state-space model formed by (\ref{eq:nonlinear_state_equation}) and \ref{eq:nonlinear_output_equation}) is a combination of a differential equation and some nonlinear equation. But in a standard state-space model the solution of the state equation does not depend on the output equation at all. However, this situation can be generalized in a way that solution of the differential equation does depend on the solution of the nondifferential (algebraic) equation. Such equations are called differential-algebraic equations (DAE). Generally,

\begin{align}\label{eq:nonlinear_DAE}
 \frac{\mathrm{d} \boldsymbol x(t)}{\mathrm{d}t} &= \mathbf f(\boldsymbol x(t),\boldsymbol u(t),t), \quad \boldsymbol x(t_0) = \boldsymbol x_0,\\
 \mathbf 0 &= \mathbf g(\boldsymbol x(t), \boldsymbol u(t), t)
\end{align}

There is a caveat here. Now the initial value $\boldsymbol x(t_0)$ needs to be consistent with the output equation! In other words, the set of variables $\boldsymbol x(t)$ is now redundant. That is why $\boldsymbol x$ is called a \textit{semi-state} variable.

The model could be made even more general by considering implicit differential equation.

\begin{equation}\label{eq:nonlinear_implicit_DAE}
 \boldsymbol 0 = \mathbf F\left(\frac{\mathrm{d} \boldsymbol x(t)}{\mathrm{d}t}, \boldsymbol x(t),\boldsymbol u(t),t\right), \quad \boldsymbol x(t_0) = \boldsymbol x_0.\\
\end{equation}

The model can, however, be also found in a more restricted form of a \textit{descriptor system}

\begin{align}
 \mathbf E\dot{\boldsymbol x}(t) &= \mathbf A\boldsymbol x(t) + \mathbf B\boldsymbol u(t),\\
 \boldsymbol y(t) &= \mathbf C\boldsymbol x(t) + \mathbf D\boldsymbol u(t),
\end{align}
where the matrix $\mathbf E$ is singular (or close to singular). If it were not, one could easily get the standard state space model just by multiplying both sides of the differential equation by the inverse of $\mathbf E$. 

To demonstrate the concepts, let us explore one example of an electronic circuit in Fig.\ref{fig: RLC circuit}. 

\begin{figure}[ht]
 \centering
\begin{tikzpicture}
\begin{circuitikz}
\draw (0,0)
to [european voltage source,v^<=$u_0$] (0,6); 
\draw (0,6)--(3,6);
\draw (3,6)
to [R,l=$R_1$,*-*,i=$i_{\mathrm{R}_1}$,v_>=$u_{\mathrm{R}_1}$] (3,3)
to [R,l=$R_2$,-*,i=$i_{\mathrm{R}_2}$,v_>=$u_{\mathrm{R}_1}$] (6,3)
|- (0,0); 
\draw (3,6) 
-- (6,6)
to [L,l=$L$,i=$i_\mathrm{L}$,v_>=$u_{\mathrm{L}}$] (6,3);
\draw (3,3)
to [C=$C$,-*,i=$i_\mathrm{C}$,v_>=$u_{\mathrm{C}}$] (3,0);
\end{circuitikz}
\end{tikzpicture}
\caption{Circuit diagram of an electrical RLC circuit.}
\label{fig: RLC circuit}
\end{figure}

The first five equations are just models of the individual components, the capacitor and the inductor described in the format displaying the derivatives of state variables: 

\begin{align}
 u_0 &= 10,\\
 u_{\mathrm{R}_1}(t) - R_1i_{\mathrm{R}1}(t) &= 0,\\
 u_{\mathrm{R}_2}(t) - R_2i_{\mathrm{R}2}(t) &= 0,\\
 i_\mathrm{C}(t) - C\frac{\mathrm{d}u_\mathrm{C}}{\mathrm{d}t}(t) &= 0,\\
 u_\mathrm{L}(t) - L\frac{\mathrm{d}i_\mathrm{L}}{\mathrm{d}t}(t) &= 0.
\end{align}

The other three equations come out from a direct application of Kirchhoff's Voltage Law:

\begin{align}
 u_0 - u_{\mathrm{R}_1}(t) - u_\mathrm{C}(t) &= 0,\\
 u_\mathrm{L}(t) - u_{\mathrm{R}_1}(t) - u_{\mathrm{R}_2}(t) &= 0,\\
 u_\mathrm{C}(t) - u_{\mathrm{R}_2}(t) &= 0.
\end{align}

The remaining equations are obtained by application of Kirchhoff's Current Law. There are three nodes, but we only need two equations (to have 10 equations in total for 10 variables). The explanation is that the currents through the three nodes are not completely independent, in other words, one of the three equations is necessarily redundant (linearly dependent) and need not be considered. It is customary to regard the ground node as the redundant guy. The remaining equations are thus

\begin{align}
 i_0 - i_{\mathrm{R}1}(t) - i_\mathrm{L}(t) &= 0,\\
 i_{\mathrm{R}1}(t) - i_{\mathrm{R}2}(t) - i_\mathrm{C}(t) &= 0.
\end{align}

What we obtained is a set of differential and algebraic equations, that is, an implicit DAE model. In principle we could stop here since there are both analytical and numerical tools to handle these as the Matlab code below demonstrates.

\begin{lstlisting}
L = 0.0015;     % [H]
C = 1e-6;       % [F]
R1 = 100;       % [Ohm]
R2 = 20;        % [Ohm]
U0 = 10;        % [V]

E = zeros(9,9);
E(1,8) = C;
E(2,7) = L;

A = zeros(9,9);
A(1,9) = 1;
A(2,6) = 1;
A(3,2) = 1;
A(3,3) = -R1;
A(4,4) = 1;
A(4,5) = -R2;
A(5,2) = -1;
A(5,8) = -1;
A(6,2) = -1;
A(6,4) = -1;
A(6,6) = 1;
A(7,4) = -1;
A(7,8) = 1;
A(8,1) = 1;
A(8,3) = -1;
A(8,7) = -1;
A(9,3) = 1;
A(9,5) = -1;
A(9,9) = -1;

B = zeros(9,1);
B(5,1) = 1;

C = zeros(1,9);
C(1,5) = 1;

D = 0;

Gdae = dss(A,B,C,D,E);
set(Gdae,'InputName','u_0')
set(Gdae,'OutputName','i_R2')
set(Gdae,'StateName',{'i_0','u_R1','i_R1','u_R2','i_R2',...
'u_L','i_L','u_C','i_C'})
\end{lstlisting} 

The \texttt{dss()} constructor is used for this purpose. Note also that it is a good practice to label the inputs, outputs and the state variables.

We may want to turn this DAE model into the more familiar state-space format, if possible. In order to do that, the equations just need to be modified and reordered so that their left-hand sides can be immediately computed using the right-hand sides. Substituting from one equation to another we finally eliminate all but two variables---the state variables $u_C$ and $i_L$, which define our desired state-space model. We will not discuss any systematic procedure for such conversion in this introductory lecture since this will be a topic for one of the future lectures (the one on simulation of DAE systems). Instead, we will state the model directly here

\begin{align}
 \begin{bmatrix}
  \frac{\mathrm d u_\mathrm{C}(t)}{\mathrm d t} \\ \frac{\mathrm d i_\mathrm{L}(t)}{\mathrm d t}
 \end{bmatrix}
&= 
 \begin{bmatrix}
  -\frac{R_1+R_2}{R_1R_2+C} & 0\\ 0 & 0
 \end{bmatrix}
 \begin{bmatrix}
  u_\mathrm{C}(t) \\ i_\mathrm{L}(t)
 \end{bmatrix}
+
 \begin{bmatrix}
  \frac{1}{R_1 C} \\ \frac{1}{L}
 \end{bmatrix}
 u_0\\
 i_{\mathrm{R}_2}(t)
&= 
 \begin{bmatrix}
  \frac{1}{R_2} & 0
 \end{bmatrix}
 \begin{bmatrix}
  u_\mathrm{C}(t) \\ i_\mathrm{L}(t)
 \end{bmatrix}
+
 0 u_0.
\end{align}

Our state-space model can be easily encoded in Matlab using the \texttt{ss()} constructor:

\begin{lstlisting}
A = [-(R1+R2)/(R1*R2*C), 0; 0, 0];
B = [1/(R1*C); 1/L];
C = [1/R2, 0];
D = 0;

Gss = ss(A,B,C,D);

set(Gss,'InputName','u_0')
set(Gss,'OutputName','i_R2')
set(Gss,'StateName',{'u_C','i_L'})
\end{lstlisting}

Whether using one or the other model, you can now start analyzing the responses to input signal, stability and so on. You will learn soon during such experiments that the set of tools for state-space models is much wider then for DAEs.

We will have more to say on software in one of the next lectures.

\subsubsection{Second-order model}
Whereas the electrical circuits discussed above are very conveniently described by first-order differential equations, the mechanical systems are very naturally described by second-order differential equations. Recall that the second Newton's law determines the second derivative of position. Although these second-order equations could be in principle converted to first-order state-space models, it is sometimes preferrable not to do so. There may be two reasons. First, numerical issues. Second, the structure is then lost.

Consider a mechanical system consisting of multiple masses interconnected by springs and dampers. The natural model describing deviations $x_i$ of the individual masses (indexed by $i$) from their equilibrium positions is

\begin{equation}
 \mathbf M\ddot{\boldsymbol x}(t) + \mathbf D \dot{\boldsymbol x}(t) + \mathbf K \boldsymbol x(t) = \mathbf B \boldsymbol u(t), 
\end{equation}
where $\boldsymbol x(t)=\begin{bmatrix}x_1(t),\,x_2(t),\,\ldots,x_n(t) \end{bmatrix}^\text{T}$ is no longer a state vector but the vector consisting only of the positional variables (no velocities), the matrix $\mathbf M$ is called a generalized mass matrix, $\mathbf D$ is a damping matrix and $\mathbf K$ is a stifness matrix. The vector input $\boldsymbol u$ corresponds to forces applied to individual masses. This model can possibly be accompanied by the output equation

\begin{equation}
 \boldsymbol y = \mathbf C_x \boldsymbol x(t) + \mathbf C_v \dot{\boldsymbol x}(t).
\end{equation}
 
In order to verify our mastering of the concepts, let us consider an example as in Fig.~\ref{fig:multiple_masses_dampers_springs}

\begin{figure}[ht]
\centering
\begin{tikzpicture}[every node/.style={draw,outer sep=0pt,thick}]
\tikzstyle{spring}=[thick,decorate,decoration={zigzag,pre length=0.3cm,post length=0.3cm,segment length=6}]
\tikzstyle{damper}=[thick,decoration={markings,  
  mark connection node=dmp,
  mark=at position 0.5 with 
  {
    \node (dmp) [thick,inner sep=0pt,transform shape,rotate=-90,minimum width=15pt,minimum height=3pt,draw=none] {};
    \draw [thick] ($(dmp.north east)+(2pt,0)$) -- (dmp.south east) -- (dmp.south west) -- ($(dmp.north west)+(2pt,0)$);
    \draw [thick] ($(dmp.north)+(0,-5pt)$) -- ($(dmp.north)+(0,5pt)$);
  }
}, decorate]
\tikzstyle{ground}=[fill,pattern=north east lines,draw=none,minimum width=0.75cm,minimum height=0.3cm]

%=============================================================================
\node (M1) [minimum width=1cm, minimum height=1.5cm] {$m_1$};

\node (A1) [coordinate, above of=M1, yshift=0cm]{};
\draw[->] let \p1=(A1) in (A1) -- node[draw=none,yshift=3mm]{$\dot x_1$}(\x1+5mm,\y1); 

\node (ground1) [ground,anchor=north,yshift=-0.25cm,minimum width=1.5cm] at (M1.south) {};
\draw (ground1.north east) -- (ground1.north west);
\draw [thick] (M1.south west) ++ (0.2cm,-0.125cm) circle (0.125cm)  (M1.south east) ++ (-0.2cm,-0.125cm) circle (0.125cm);

\node (wall) [ground, rotate=-90, minimum width=2cm,yshift=-3cm] {};
\draw (wall.north east) -- (wall.north west);

\draw [spring] (wall.160) -- ($(M1.north west)!(wall.160)!(M1.south west)$);
\draw [damper] (wall.20) -- ($(M1.north west)!(wall.20)!(M1.south west)$);

%=============================================================================
\node (M2) [minimum width=1cm, minimum height=1.5cm,xshift=3cm] {$m_2$};

\node (A2) [coordinate, above of=M2, yshift=0cm]{};
\draw[->] let \p2=(A2) in (A2) -- node[draw=none,yshift=3mm]{$\dot x_2$}(\x2+5mm,\y2);

\node (ground2) [ground,anchor=north,yshift=-0.25cm,minimum width=1.5cm] at (M2.south) {};
\draw (ground2.north east) -- (ground2.north west);
\draw [thick] (M2.south west) ++ (0.2cm,-0.125cm) circle (0.125cm)  (M2.south east) ++ (-0.2cm,-0.125cm) circle (0.125cm);
\draw [spring] (M1.40) -- ($(M2.north west)!(M1.40)!(M2.south west)$);
\draw [damper] (M1.-40) -- ($(M2.north west)!(M1.-40)!(M2.south west)$);

%=============================================================================
\node (M3) [minimum width=1cm, minimum height=1.5cm,xshift=6cm] {$m_3$};

\node (A3) [coordinate, above of=M3, yshift=0cm]{};
\draw[->] let \p3=(A3) in (A3) -- node[draw=none,yshift=3mm]{$\dot x_3$}(\x3+5mm,\y3);

\node (ground3) [ground,anchor=north,yshift=-0.25cm,minimum width=1.5cm] at (M3.south) {};
\draw (ground3.north east) -- (ground3.north west);
\draw [thick] (M3.south west) ++ (0.2cm,-0.125cm) circle (0.125cm)  (M3.south east) ++ (-0.2cm,-0.125cm) circle (0.125cm);
\draw [spring] (M2.40) -- ($(M3.north west)!(M2.40)!(M3.south west)$);
\draw [damper] (M2.-40) -- ($(M3.north west)!(M2.-40)!(M3.south west)$);

\draw [-latex,ultra thick] (M3.east) ++ (0.2cm,0) -- node[draw=none, yshift=3mm]{$F$} +(1cm,0);
\end{tikzpicture}
\caption{Multiple masses, springs and dampers. Could be a real system or just an approximation to a flexible structure.}
\label{fig:multiple_masses_dampers_springs}
\end{figure}

The Newton equations for the three masses are 
\begin{align}
m_1 \ddot x_1(t) &= -k_1x_1(t) -d_1\dot x_1(t) + k_2(x_2(t)-x_1(t)) + d_2(\dot x_2(t) - \dot x_1(t)),\\
m_2 \ddot x_2(t) &= -k_2(x_2(t)-x_1(t)) -d_2(\dot x_2(t) - \dot x_1(t))\nonumber \\
		 &\qquad\qquad\qquad\qquad\qquad + k_3(x_3(t)-x_2(t)) + d_3(\dot x_3(t) - \dot x_2(t)),\\
m_3 \ddot x_3(t) &= -k_3(x_3(t)-x_2(t)) -d_3(\dot x_3(t) - \dot x_2(t)) + F(t).
\end{align}
where the $k$s are the stiffness constants for the three springs and $d$s are the coefficients for the three dampers. We can immediately rewrite this into the format of $M$, $D$ and $K$ matrices

\begin{multline}
\begin{bmatrix}
m_1 & &\\
 & m_2 & \\
 & & m_3 
\end{bmatrix}
\begin{bmatrix}
 \ddot x_1 \\\ddot x_2\\\ddot x_3
\end{bmatrix}
+
\begin{bmatrix}
 (k_1+k_2) & -k_2 & \\
-k_2 & (k_2+k_3) & -k_3\\
 & -k_3 & k_3
\end{bmatrix}
\begin{bmatrix}
x_1 \\x_2\\x_3 
\end{bmatrix}
\\+
\begin{bmatrix}
  (d_1+d_2) & -d_2 & \\
-d_2 & (d_2+d_3) & -d_3\\
 & -d_3 & d_3
\end{bmatrix}
\begin{bmatrix}
 \dot x_1 \\\dot x_2\\\dot x_3
\end{bmatrix}
=
\begin{bmatrix}
 \\ \\1 
\end{bmatrix}
F(t). 
\end{multline}

The procedure for conversion to state-space model is fairly straightforward and students are asked to check they are able to reproduce it:

\begin{equation}
 \begin{bmatrix}\dot{\boldsymbol x}(t)\\ \ddot{\boldsymbol x}(t)\end{bmatrix}
= 
\begin{bmatrix} \mathbf 0 & \mathbf I\\ -\mathbf M^{-1}\mathbf K & -\mathbf M^{-1}\mathbf D\end{bmatrix}
 \begin{bmatrix}\boldsymbol x(t)\\ \dot{\boldsymbol x}(t)\end{bmatrix}
+
\begin{bmatrix}\mathbf 0\\ \mathbf M^{-1}\mathbf B\end{bmatrix} 
u(t).                               
\end{equation}

Observing that the process of creating an equivalent state-space description includes numerical inversion of the mass matrix, it is then easily understood that numerical troubles might be expected for large-scale systems. Similarly, the structure enjoyed by the matrices $\mathbf M$, $\mathbf D$ and $\mathbf K$ does not easily transform to the structure of the corresponding state-space matrices. We will not elaborate more on this in our course. This was just to inform you that there are reasons for keeping the models in the format of second-order differential equations. The analysis and control synthesis techniques have been developed for these models. 

However artificial these systems consisting of multiple massess, springs and dampers might look, they actually consitute a reasonable model of fairly common mechanical systems---flexible mechanical structures. Noble examples are flexible cantilevers for atomic force microsopes (AFM) or flexible wing aircraft. One approach how to model these systems is to discretize them spatially, which leads exactly to the model described above. The dimensions of the coresponding matrices can be, however, huge. Hundreds or easily hundred thousands\ldots 

Another instance of second-order systems may be found in the field of robotics. The matrices are then dependend on the the state variables. Now, instead of $x$, a different symbol is used --- $q$, which makes it possible to include both translational and rotational coordinates. $q_i$s are called generalized coordinates. We will have more to say on this later. The second-order model for a robotic manipular is frequently found in the format

\begin{equation}
 \mathbf M(\boldsymbol q)\ddot{\boldsymbol q}(t) + \mathbf D(\boldsymbol q,\dot{\boldsymbol q}) \dot{\boldsymbol q}(t) + \mathbf K(\boldsymbol q) = \mathbf B \boldsymbol u(t), 
\end{equation}
  
More on this later in this course when we are exploring the classical analytical techniques known under the name of Lagrangian modeling.

\subsubsection{Systems of $n$-th order, polynomial matrix fractions}
We started with first-order systems, and then proceeded with second-order systems. It is obvious that $n$-th order systems (for $n>2$) must be mentioned as well. There are perhaps not many analytical tools for general nonlinear differential equations of order $n$ but the situation is different in the linear case.

Denote as usual the independent (input) variable by $u$ and the dependent (output) variable as $y$. The standard linear ordinary differential equation of order $n$ is 

\begin{multline}
 a_{n}y^{(n)}(t) + a_{n-1}y^{(n-1)}(t)+\ldots + a_{1}\dot y(t) + a_{0}y(t) \\= b_{m}u^{(m)}(t) + b_{m-1}u^{(m-1)}(t)+\ldots + b_{1}\dot u(t) + b_{0}u(t).
\end{multline}

Applying Laplace transform while assuming zero initial conditions, the differential equation is transformed into an algebraic equation, in particular a polynomial equation

\begin{equation}
 (a_{n}s^n + a_{n-1}s^{n-1}+\ldots + a_{1}s + a_{0}) Y(s) = (b_{m}s^m + b_{m-1}s^{m-1}+\ldots + b_{1} + b_{0})U(s).
\end{equation}
 
The last step to express how $Y(s)$ depends on $U(s)$ is to perform a \emph{formal} inversion of the polynomial $a(s)$. The intended inversion is indeed just formal, resulting in the popular fraction of two polynomials, well known as \emph{transfer function} 

\begin{equation}
 Y(s) = \underbrace{\frac{(b_{m}s^m + b_{m-1}s^{m-1}+\ldots + b_{1} + b_{0})}{(a_{n}s^n + a_{n-1}s^{n-1}+\ldots + a_{1}s + a_{0})}}_{G(s)}U(s).
\end{equation}

In Matlab, the constructor \texttt{tf()} can be used to create an object of class the transfer function.

This last step easily extends to the scenario with several inputs and several outputs, where several $n$-the linear differential equations are available. Applying Laplace transform, the set of ODEs is transformed into a set of polynomial equations. These can be written in a matrix format

\begin{equation}
 \mathbf A(s)\boldsymbol Y(s) = \mathbf B(s)\boldsymbol U(s),
\end{equation}
where $\boldsymbol Y(s)$ and $\boldsymbol U(s)$ are vectors of the transformed outputs and inputs, respectively, and $\mathbf A(s)$ and $\mathbf B(s)$ are now matrix polynomials (or polynomial matrices).

Now, what constitutes the right analogy to the transfer function in the MIMO case? A matrix of transfer function? Actually no. The natural extension is just a polynomial matrix fraction. That is, a fraction of two polynomial matrices

\begin{equation}
 \boldsymbol Y(s) = \underbrace{\mathbf A^{-1}(s)\mathbf B(s)}_{\mathbf G(s)}\boldsymbol U(s).
\end{equation}

Note that as matrices are not commutative, it matters whether the multiplication by the inverse of $\mathbf A(s)$ is done from the left or from the right. In the above, the model is in the form of a left matrix fraction. More on this in the graduate course on Linear course given currently by Petr Hušek.

We would like to mention here that this particular approach to linear systems based on fractions of polynomials and polynomial matrices has major part of its roots in the research of professor Vladimír Kučera and professor Michael Šebek and a number of their colleagues at Academy of Sciences of the Czech Republic. As a product of this research, Polynomial toolbox was created, which contains a set of functions for polynomial matrices. Entering a polynomial matrix is as easy as writing

\begin{lstlisting}
>> A = [s^2+1, s; 5*s^3+6*s^2+3, 1]
    
A = 
    
     1 + s^2             s
     3 + 6s^2 + 5s^3     1
\end{lstlisting}


\subsubsection{Spatially distributed systems---partial differential equations}
The modeling methodology introduced in this course will primarily focus on \textit{lumped systems}. We can hardly feed our ambitions to step systematically into the discipline of modeling spatially distributed systems within this course. This would force us to study the mathematically advanced topic of \textit{partial differential equations} (PDE), which is a broad subject of study on its own. Nonetheless, we will be able to use our tools for lumped systems to get approximate (typically low-order) models for spatially distributed systems. 

As an example, consider the standard \textit{transmission line} model (probably you have discussed this in some previous course on electric circuits). The full PDE model is

\begin{align}
\frac{\partial u(x,t)}{\partial x} &= -Ri(x,t) -L\frac{\partial i(x,t)}{\partial t},\\
\frac{\partial i(x,t)}{\partial x} &= -Gu(x,t) -C\frac{\partial u(x,t)}{\partial t}, 
\end{align}
where $R, L, G$ and $C$ are resistance, inductance, admittance and capacitance, respectively, related to a unit lenght of the transmission line. 

In order to analyze the system, one would have to work with the two PDEs, arriving to the well-known wave equation after a while. We can, however, get a very useful qualitative results (and usable quantitative outcomes as well) if we approximate the continuum model by the one in Fig.~\ref{fig:finite_model_transmission_line}. For that we could use the concepts presented in this course.

\begin{figure}[ht]
 \centering
\begin{tikzpicture}[scale=0.5]
    \begin{circuitikz}[scale=0.7,transform shape]
	\draw
	  (0,2) node {}
	  to [R,l=$R\,\Delta x$,short,o-] (2,2)  
	  to [L,l=$L\,\Delta x$] (4,2) 
	  to [C,l=$C\,\Delta x$,*-*] (4,0)
	  to [short,-o](0,0) node{}; 
	  \draw (4,2)--(6,2)
	  to [R,l=$G\,\Delta x$,*-*] (6,0)
	  to (4,0);
	  \draw (6,2)
	  to [R,l=$R\,\Delta x$] (8,2)  
	  to [L,l=$L\,\Delta x$] (10,2) 
	  to [C,l=$C\,\Delta x$,*-*] (10,0)
	  to (6,0);
	  \draw (10,2)--(12,2)
	  to [R,l=$G\,\Delta x$,*-*] (12,0)
	  to (10,0);
          \draw (12,2)
	  to [R,l=$R\,\Delta x$] (14,2)  
	  to [L,l=$L\,\Delta x$] (16,2) 
	  to [C,l=$C\,\Delta x$,*-*] (16,0)
	  to (12,0);
	  \draw (16,2)--(18,2)
	  to [R,l=$G\,\Delta x$,*-*] (18,0)
	  to (16,0);
	  \draw[dotted] (18,2)--(19,2);
	  \draw[dotted] (18,0)--(19,0);
      \end{circuitikz}
    \end{tikzpicture}
\caption{A few sections for a finite-dimensional model of a transmission line.}
\label{fig:finite_model_transmission_line}
\end{figure}

\subsection{Acausal models (also equation-based, energy-based)}

Why did we call the formats in the previous section as \textit{causal} or \textit{signal-based} or \textit{assignment based}? Because we got stuck to an input-output viewpoint, whether we wanted it or no: one variable (possibly a vector variable) is an input to the system and another variable (or a set of variables) represents a response, which we call an output. Remember that when we write 

\begin{equation}
 y(t) = g(x,u,t),
\end{equation}
we actually mean (using the computer programming style)
\begin{equation}
 y(t) := g(x,u,t),
\end{equation}
or even better
\begin{equation}
 y(t) \leftarrow g(x,u,t).
\end{equation}

That is, take the inputs (and possibly the states if there are any), do some manipulation with them and \textit{assign} them to the output. Hence, assignment-based modeling. Equivalently, in a graphical format of popular block diagrams (Simulink style)

\tikzstyle{block} = [draw, fill=blue!20, rectangle,minimum height=3em, inner sep=1mm]
\tikzstyle{input} = [coordinate, inner sep=1mm]
\tikzstyle{output} = [coordinate, inner sep=1mm]
\tikzstyle{sum} = [draw, fill=blue!20, circle, node distance=1.2cm, minimum size=3mm, inner sep=1mm]
\tikzstyle{pinstyle} = [pin edge={to-,thin,black}]

\begin{figure}[ht]
 \centering
\begin{tikzpicture}[auto, node distance=3cm,>=latex']
\node [input, name=input] {};
\node [block, right of=input] (system) {System};
\node [output, right of=system] (output) {};
\draw [draw,->] (input) -- node {$u(t)$} (system);
\draw [->] (system) -- node {$y(t)$} (output);
\end{tikzpicture}
 \caption{\textit{Signal flow} model of a system (aka \textit{block diagram}).}
 \label{fig:signal_flow}
\end{figure}

Why do we need to study anything else? Or do we? Well, the major shortcoming of assignment-based (or signal-based) models is that they do not allow building a model of a more complex system by interconnection of subsystems and components. Consider just a simple DC rotary motor with a permanent magnet. Finding a model is a well-mastered task. Then consider a mechanical load on the motor shaft, its mechanical model relating the input torque and the velocity is even simpler. Say, both models are in Simulink format. Now connect the two models together. Is it possible to obtain something like Fig.\ref{fig:motor_and_load_signal_flow} suggests?

\begin{figure}[ht]
 \centering
\begin{tikzpicture}[auto, node distance=3cm,>=latex', inner sep=1mm]
\node [input, name=input] {};
\node [block, right of=input] (motor) {Motor};
\node [block, right of=motor] (load) {Mechanical load};
\node [output, right of=load] (output) {};
\draw [draw,->] (input) -- node {$u(t)$} (system);
\draw [->] (motor) -- node {?} (load);
\draw [->] (load) -- node {$\omega(t)$} (output);
\end{tikzpicture}
 \caption{Block diagram for an interconnection of a motor and a load.}
 \label{fig:motor_and_load_signal_flow}
\end{figure}

The situation is detailed in Fig.~\ref{fig:motor_and_load_block_diagram}, where the motor and the mechanical motor are modeled using block diagrams in Simulink style. 

\begin{figure}[ht]
 \centering
\begin{subfigure}[b]{0.9\textwidth}
\centering
\begin{tikzpicture}[auto, node distance=1.5cm,>=latex',inner sep=1mm]
    % We start by placing the blocks
    \node [input, name=input] {};
    \node [sum, right of=input,node distance=1.5cm] (sum_U) {};
    \node [block, right of=sum_U] (LR) {$\frac{1}{Ls+R}$};
    \node [right of=LR,regular polygon,regular polygon sides=3,shape border rotate=-90,draw, fill=blue!20, minimum height=3em,inner sep=0] (kt) {$k_t$};
    \node [sum, right of=kt,node distance=1.5cm] (sum_T) {};
    \node [right of=sum_T,regular polygon,regular polygon sides=3,shape border rotate=-90,draw, fill=blue!20, minimum height=3em,inner sep=0] (J) {$\frac{1}{J_\mathrm{m}}$};
    \node [block, right of=J] (integrator_w) {$\frac{1}{s}$};
    \node [block, right of=integrator_w] (integrator_theta) {$\frac{1}{s}$};
    \node [output, right of=integrator_theta] (output){};
    \node [below of= integrator_w,regular polygon,regular polygon sides=3,shape border rotate=90,draw, fill=blue!20, minimum height=3em,inner sep=0] (b) {$b$};
    \node [below of= b,regular polygon,regular polygon sides=3,shape border rotate=90,draw, fill=blue!20, minimum height=3em,inner sep=0] (ke) {$k_e$};

    \draw [draw,->] (input) -- node {$u$} (sum_U);
    \draw [->] (sum_U) -- node {} (LR);
    \draw [->] (LR) -- node {} (kt);
    \draw [->] (kt) -- node {$T_m$}(sum_T);
    \draw [->] (sum_T) -- (J);
    \draw [->] (J) -- (integrator_w);
    \draw [->] (integrator_w) -- node [name=w]{$\omega$}(integrator_theta);
    \draw [->] (integrator_theta) -- node {$\theta$} (output);
    \draw [->] (w) |- (b);
    \draw [->] (w) |- (ke);
    \draw [->] (b) -| node[pos=0.90] {$-$}node[pos=0.10] {$T_\mathrm{friction}$}(sum_T);
    \draw [->] (ke) -| node[pos=0.95] {$-$}node[pos=0.1] {$u_\mathrm{back emf}$}(sum_U);
\end{tikzpicture}
\caption{Block diagram of a DC motor with a permanent magnet.}
\end{subfigure}\\ \vspace{1cm}

\begin{subfigure}[b]{0.9\textwidth}
  \centering
  \begin{tikzpicture}[auto, node distance=1.5cm,>=latex',inner sep=1mm]
    \node [input, name=input] {};
    \node [right of=input,regular polygon,regular polygon sides=3,shape border rotate=-90,draw, fill=blue!20, minimum height=3em,inner sep=0] (Jl) {$\frac{1}{J_\mathrm{l}}$};
    \node [block, right of=Jl] (integrator_w_load) {$\frac{1}{s}$};
    \node [output, right of=integrator_w_load] (output){};
    \draw [draw,->] (input) -- node {$T$} (Jl);
    \draw [->] (Jl) -- (integrator_w_load);
    \draw [->] (integrator_w_load) -- node {$\omega_\mathrm{load}$} (output);
  \end{tikzpicture}
  \caption{Block diagram of a rotational load.}
\end{subfigure}
\caption{Block diagrams for a DC motor with permanent magnet and a load.}
\label{fig:motor_and_load_block_diagram}
\end{figure}

The answer to the question preceeding Fig.~\ref{fig:motor_and_load_signal_flow} is negative! Apparently, unless the moment of inertia is negligible, the load will also influence the angular rate of the motor. Obviously we would expect some kind of a mutual coupling of the two blocks. But how do we represent this coupling? In this particular case we know that the resulting model inherits the structure of the model of the motor but instead of $J_\mathrm{m}$ we need to consider the total load as "seen" by the motor, that is $J_\mathrm{m}+J_\mathrm{l}$.

Another viewpoint at the source of the troubles here is that with block diagrams (signal flows) we have to specify the inputs and the outputs first, and only then we can start building the model. This has a major consequence on our capability or actually incapability to create libraries of basic elements. Consider just a single resistor. What is its mathematical model? The key phenomenon is that a resistor delivers a linear relationship between the voltage and the current due to Ohm's law. We can write

\begin{equation}
 u(t) = Ri(t)
\end{equation}
but we can also equally well write 
\begin{equation}
 i(t) = \frac{1}{R}u(t).
\end{equation}

Which one of the two models is correct? Note that both will have different implementation in Simulink as the Fig.~\ref{fig:two_resistors} shows.

\begin{figure}[ht]
 \centering
  \begin{subfigure}[b]{0.3\textwidth}
      \begin{tikzpicture}[auto, node distance=2cm,>=latex']
      \node [input, name=input] {};
      \node [right of=input,regular polygon,regular polygon sides=3,shape border rotate=-90,draw, fill=blue!20, minimum size=20mm, inner sep=1mm] (resistor) {$R$};
      \node [output, right of=resistor] (output) {};
      \draw [draw,->] (input) -- node {$i(t)$} (resistor);
      \draw [->] (resistor) -- node {$u(t)$} (output);
      \end{tikzpicture}
      \caption{Current as the input to the model.}
      \label{fig:two_resistors_a}
  \end{subfigure}
  \qquad
  \begin{subfigure}[b]{0.3\textwidth}
      \begin{tikzpicture}[auto, node distance=2cm,>=latex']
      \node [input, name=input] {};
      \node [right of=input,regular polygon,regular polygon sides=3,shape border rotate=-90,draw, fill=blue!20, minimum size=20mm, inner sep=1mm] (resistor) {$\frac{1}{R}$};
      \node [output, right of=resistor] (output) {};
      \draw [draw,->] (input) -- node {$u(t)$} (resistor);
      \draw [->] (resistor) -- node {$i(t)$} (output);
      \end{tikzpicture}
      \caption{Voltage as the input to the model.}
      \label{fig:two_resistors_b}
  \end{subfigure}
\caption{Two different models of a resistor, depending on the causality.}
\label{fig:two_resistors}
\end{figure}

Of course, both models are correct, nonetheless, a choice of the model depends on the circumstances---whether it is the current or the voltage that is enforce on the resistor. We had to specify the cause and the consequence, hence a causal model.

\subsubsection{Bond graphs}

Let's finally start exploring the alternatives. The solution to avoid the troubles induced by causality is to \textit{avoid specifying the inputs and outputs}, hence \textit{acausal modeling}. Equivalently, the interactions among the models will be realized not via signals but via energy exchange. Hence our model of a motor and a load should look like in Fig.~\ref{fig:motor_and_load_verbal_bond_graph}

\begin{figure}[ht]
 \centering
\begin{tikzpicture}[auto, node distance=3cm,>=latex', inner sep=1mm]
\node [block, right of=input] (motor) {Motor};
\node [block, right of=motor] (load) {Mechanical load};
\draw [-] (motor) -- (load);
\end{tikzpicture}
 \caption{Exchange of energy between a motor and a load.}
 \label{fig:motor_and_load_verbal_bond_graph}
\end{figure}

The link between the two subsystems must now be interpretted as a (bidirectional) exchange of energy between the two systems, flow of energy, power. We call it a power bond and the above diagram is our first instance of a \textit{bond graph}. We can immediately demonstrate its convenience by extending the system with a model of a source of (electrical) energy, say, the battery, see Fig.~\ref{fig:motor_and_load_and_battery_verbal_bond_graph} 

\begin{figure}[ht]
 \centering
\begin{tikzpicture}[auto, node distance=4cm,>=latex', inner sep=1mm, minimum width=3cm]
\node [block] (battery) {Battery};
\node [block,right of=battery] (motor) {Motor};
\node [block, right of=motor] (load) {Mechanical load};
\draw (battery) to [edge label=$\tau$,edge label'=$\omega$] (motor);
\draw (motor) to [edge label=$\tau$,edge label'=$\omega$] (load);
\end{tikzpicture}
 \caption{Bond graph for a motor and a load and a battery.}
 \label{fig:motor_and_load_and_battery_verbal_bond_graph}
\end{figure}

A noteworthy feature of the above model is that the two interfaces above are realized in two different physical domans---electrical and mechanical, and yet both of them can be uniformly quantitavely characterized in the same units---Watts! Energy (or power) seems to be a perfect universal currency. All our modeling in this course will be aimed at developing techniques for depicting the flow of energy in the system.

Let's stay for a while with the electrical bond (the one between the battery and the motor). As aspiring members of electrical engineering community we have already encountered another formalism for expressing this interaction---the one-port, two-port and in general \textit{multiport} framework, see Fig.~\ref{fig:battery_motor_one_ports_disconnected}. Both the batery and the motor are described here as one-ports. Each port is characterized by a voltage across the two pins and the current entering through one pin and leaving through the other. The interconnection of the two one-pins then amounts to connecting the corresponding pins as in Fig.~\ref{fig:battery_motor_one_ports_connected}.

\begin{figure}[ht]
 \centering
  \begin{subfigure}[b]{0.9\textwidth}
    \begin{tikzpicture}
      \begin{circuitikz}
	\draw
	  (1,0) node [anchor=west]{$u_1^-$} 
	  to [short,o-] (0,0) 
	  to [battery](0,2) 
	  to [short,-o,i=$i_1$](1,2) node [anchor=west]{$u_1^+$}; 
	\draw
	  (4,2) node [anchor=east]{$u_2^+$}
	  to [R,l=$R$,i=$i_2$,short,o-] (7,2)  
	  to [L,l=$L$] (9,2) 
	  to (9,2)
	  to [V,l=$v_\mathrm{emf}$] (9,0)
	  to [short,-o](4,0) node [anchor=east]{$u_2^-$}; 
      \end{circuitikz}
    \end{tikzpicture}
  \caption{A battery and a motor as one-ports. Each port characterized by a voltage across the pins and the current entering one pin and leaving the other.}
  \label{fig:battery_motor_one_ports_disconnected}
  \end{subfigure}\\
\vspace{1cm}
  \begin{subfigure}[b]{0.9\textwidth}
    \centering
    \begin{tikzpicture}[auto, node distance=3cm,>=latex', inner sep=1mm, minimum width=2cm]
    \node [block] (battery) {Battery};
    \node [block, right of=battery] (motor) {Motor};
    \draw[blue] (battery.15) --  (motor.165);
    \draw[blue] (battery.-15) -- (motor.-165);
    \end{tikzpicture}
  \caption{Interconnection of a battery and a motor as an interconnection of two one-ports. The two lines need to be literally interpretted as wires; the power bond is characterized by the voltage across the two wires and current flowing through one corrent from one system to another and back through the other wire.}
  \label{fig:battery_motor_one_ports_connected}
  \end{subfigure}
\caption{Electrical interconnection of a battery and a motor.}
\label{fig:battery_motor_one_ports}
\end{figure}

As a matter of fact, the (multi)port formalism is what we are after. In other physical domains, however, there are no pins, no plus and minus leads. Therefore, graphically we will depict the existence of an exchange of energy by a single undirected line. 

Taking further inspiration from the electrical engineering, the product of the two variables that characterized the port---the voltage $v=v^+-v^-$ and the current $i$---yields a power $\mathcal{P}$ (in \si{\watt}). Can we find a similar pair of variables in mechanical domain? Yes. In the rotational mechanical domain the two variables are \textit{torque} $\tau$ (in \si{\newton\metre}) and \textit{angular velocity} $\omega$ (in \si{\radian\per\second}). You can verify that the product of the two variables indeed yields a power. We will keep track of these two variables associated with a bond by writing their names on the two sides of the bar denoting the bond as in Fig.~\ref{fig:motor_and_load_verbal_bond_graph_labeled} 

\begin{figure}[ht]
 \centering
\begin{tikzpicture}[auto, node distance=4cm,>=latex', inner sep=1mm, minimum width=3cm]
\node [block] (battery) {Battery};
\node [block,right of=battery] (motor) {Motor};
\node [block, right of=motor] (load) {Mechanical load};
\draw (battery) to node {$u$} node[swap] {$i$} (motor);
\draw (motor) to node {$\tau$} node [swap] {$\omega$} (load);
\end{tikzpicture}
 \caption{Bond graph for an interconnection motor and a load with the labels for the two associated variables.}
 \label{fig:motor_and_load_verbal_bond_graph_labeled}
\end{figure}

\subsubsection{Maxwell's analogy}
The pairs of variables for these two and a few more physical domains that we will visit in this course are summarized in Tab.~\ref{tab:equivalent_variables}.

\begin{table}
\centering
\caption{Analogy of variables for bond graphs (Maxwell).}
\label{tab:equivalent_variables}
\begin{tabular}{l|l|l}
Physical domain & Generalized force (or effort) $e$ & Gen. velocity $\dot q$\\
 & or gen. effort & or gen. flow $f$\\
\hline
Mech. rotation & Torque $\tau$ [\si{\newton\metre}]& Angular rate $\omega$ [\si{\radian\per\second}]\\
Mech. translation & Force $F$ [\si{\newton}]& Velocity $v$ [\si{\metre\per\second}]\\
Electrical & Voltage $u$ [\si{\volt}]& Current $i$ [\si{\ampere}]\\
Hydraulic & Pressure $P$ [\si{\pascal}]& Volumetric flow $Q$ [\si{\metre\cubed\per\second}]\\
Thermal & Absolute temperature $\theta$ [\si{\kelvin}] & Entropy flux $\dot S$ [\si{\joule\per\second\per\kelvin}]\\
Thermal flow & Specific enthalpy $h$ [\si{\joule\per\kilogram}] & Mass flow $\dot m$ [\si{\kilogram\per\second}]
\end{tabular}
\end{table}

What was the key used to classify the voltage as analogous to force, that is, as an instance of a generalized effort? And how come that electric current is declared as analogous to angular velocity, that is, an instance of a generalized velocity (also flow)? As a matter of fact, the analogy that we are going to use (called Maxwell's analogy) is just one possible way but a very clever one. Consider now a general bond graph with two subsystems in Fig.~\ref{fig:A_B}.

\begin{figure}[ht]
 \centering
\begin{tikzpicture}[auto, node distance=3cm,>=latex', inner sep=1mm]
\node (A) {A};
\node[right of=A] (B) {B};
\draw (A) -- node{$e$} node[swap]{$\dot q$} (B);
\end{tikzpicture}
 \caption{Simple bond graph depicting an energy exchange between subsystems A and B.}
 \label{fig:A_B}
\end{figure}

The $e$ variable classifies as a \textit{generalized force} (also \textit{generalized effort}) as it is seen identically from the perspective of both A and B subsystems. The variable $\dot q$ (or $f$) classifies as a \textit{generalized velocity} (also \textit{generalized flow}) if it depends on whether it is viewed from the perspective of A or B. Hence, the property used to classify the variables into generalized efforts and generalized velocities (or flows) is \textit{symmetry}. As an example, consider a twin wire connecting two electrical components: voltage is identical from the perspective of both components. The current is viewed as entering one component and leaving the other. Similarly, the rope connecting two movable masses, say, two humans playing the \textit{tug-of-war} game: when one (or both) competitors are pulling, both persons feel the same force effect in their palms. However, while one person is moving backwards (the winner), the other one is moving forwards (the looser), hence the 
assymetry in velocities. Some more discussion can be found in \cite{brown_engineering_2006}.  
 
Maxwell classification even makes nice correspondence with a very fundamental classification of variables into \textit{extensive} and \textit{intensive} as done in thermodynamics. This further encourages us to pay attention to energy as the central object in modeling.

Note that for thermals system, a bit more convenient choice of variables is the (absolute) temperature $T$ [\si{\kelvin}] and the heat flow rate $\dot q$ [\si{\watt}], which, however, do not yield the power as their product! Hence, the resulting model is not exactly a bond graph but rather a pseudo-bond graph. More on this later.

In order to make sure that we got the concepts right, let us consider another example: diesel motor with a turbocharger. The three major subsystems are the motor, the compressor and the turbine. The bond graph is in Fig.~\ref{fig:diesel_motor}.

\begin{figure}[ht]
 \centering
\begin{tikzpicture}[auto, node distance=3cm,>=latex', inner sep=1mm, minimum width=2cm]
\node [block] (compressor) {Compressor};
\node [block,right of=compressor] (turbine) {Turbine};
\draw (compressor) to node (u) {$T_\mathrm{c}$} node[swap] {$\omega_\mathrm{c}$} (turbine);
\node [block, above of=u,yshift=-1cm] (engine) {Engine}; 
\draw (engine) -| node[pos=0.9,xshift=-6mm] {$w_\mathrm{co}$} node[swap,pos=0.9,xshift=6mm] {$h_\mathrm{co}$} (compressor);
\draw (engine) -| node[pos=0.9,xshift=-6mm] {$w_\mathrm{ti}$} node[swap,pos=0.9,xshift=6mm] {$h_\mathrm{ti}$} (turbine);
\node [coordinate, left of=compressor] (input){};
\node [coordinate, right of=turbine] (output){};
\node [coordinate, above of=engine,yshift=-1cm,xshift=-0.5cm] (fuel){};
\node [coordinate, above of=engine,yshift=-1cm,xshift=0.5cm] (torque){};
\draw (input) -- node {$h_\mathrm{ci}$} node[swap] {$w_\mathrm{ci}$} (compressor);
\draw (output) -- node {$h_\mathrm{to}$} node[swap] {$w_\mathrm{to}$} (turbine);
\draw[->,red] (fuel) -- node[swap,xshift=7mm]{$j_Q$}(fuel.south|-engine.north);
\draw (torque) -- node[swap,xshift=7mm]{$T_\mathrm{m}$} node[xshift=-7mm]{$\omega_\mathrm{m}$}(torque.south|-engine.north);
\end{tikzpicture}
 \caption{Bond graph for a turbocharger.}
 \label{fig:diesel_motor}
\end{figure}

The description of the function can be found elsewhere, here we focus on the energy interactions. The diesel motor has three conventional power bonds (or ports). It  exchanges a mechanical power with the shaft (the torque $T_\mathrm{m}$ and the angular velocity $\omega_\mathrm{m}$). It also exchanges power with the compressor through its air intake (the enthalpy $h_\mathrm{co}$ and the mass flow $w_\mathrm{co}$) and with the turbine through the exhaust pipe (the enthalpy $h_\mathrm{ti}$ and the mass flow $w_\mathrm{ti}$). Finally, there is also an energy income from the chemical energy of the fuel. This is not exactly a power bond with any outside subsystem since this is not a two-directional interaction. Similar analysis can be done for the remaining two subsystems, the names of the constituting variables are self-explaining. 

\subsubsection{Across-through analogy}
A competitor to the Maxwell's analogy is the so-called \textit{across-through} analogy. Sooner or later you will encounter it because it is quite popular, especially in the domain of electromechanical systems. Its major weakness is that it cannot be extended beyond these two physical domains. The variables are classified according to the way how they can be measured. Voltage and velocities can be measured \textit{across} two pins or flanges, respectively. Current and force are classified as analogous since in order to measure them, the sensor must somehow be in the path of the energy, hence the name \textit{through} variable. Disregarding the vagueness of these concepts (for instance, velocity can also be measured by integrating the acelleration, current can also be measured by Hall's sensor, which is not in the path), there is one major deficiency: an extension to hydraulic domain hardly makes sense. As the electric current is a (rate of) flow of charge, it is naturally seen as analogous to volumetric fluid 
flow. But then volumetric fluid flow is analogous to force. It then hardly contributes to developing a good intuition if we now declare (hydraulic) pressure as equivalent to velocity! And yet you can encounter this analogy very often. For example, software tools like Modelica and Simscape that we are going to introduce later in this course use it. As long as this is restricted to mechanical and electrical domains, this is acceptable and in fact offers some advantages. We will discuss this in due course.

\section{Literature}
Major portion of this course was based on \cite{brown_engineering_2006}, which is an official literature for a graduate course on MIT \cite{hogan_modeling_2006}. Notheless, this introductory lecture constitutes a compilation of materials found elsewhere, hence it is not possible to map it directly to any chapter in the book. Restricted to the book \cite{brown_engineering_2006}, the chapters 4 and 7 can serve the partial purpose of providing an overview of formats of mathematical models.

The final part of the lecture, which brough some new stuff, was based on Sections 2.1 and 2.2 from \cite{brown_engineering_2006}. It is strongly advisable to go through the text. 

Another classical books on modeling oriented towards control design is \cite{karnopp_system_2006}. Both books are biased towards so-called bond graph modeling. 

In a similar vein, the monograph \cite{cellier_continuous_1991} is written, although it is a bit dated (but the fundamentals do not change). A nice thing is that a (poor) photocopy is available on its author website at ETH. In fact, the introductory example with an RLC circuit was taken from another book by the same author \cite{cellier_continuous_2010} oriented towards simulation. 

A recommendable Czech text is a set of lecture notes \cite{horacek_2000}. 

Much inspiration for the this lecture was taken from the first two chapters of \cite{egeland_modeling_2002}. Unfortunately, the book is not easily available either in libraries or in bookstores. Some instructions on how to order it are on the course website.  

A very fine discussion of the topic of analogies among physical variables in diverse domains can be found in \cite{hogan_physical_2002}.

\bibliographystyle{plain}
\bibliography{../msd}
 

\end{document}
